Subject: Re: [PATCH v3] meson: regenerate config-list.h when Documentation changes

From: Patrick Steinhardt <[email-masked]>
Date: Thu, 12 Feb 2026 09:06:02 +0100

On Wed, Feb 11, 2026 at 06:51:02PM -0500, D. Ben Knoble wrote:
> Notes (benknoble/commits):
>     Changes from v2 (<c9ae171ee[email-masked]>):
>     
>     • Pick up (and tweak) Patrick's depfile proposal
>     • Include the script itself as a dependency
>     • Escape output paths (spaces, octothorpes, and backslashes) for Ninja
>     
>     I'm not 100% sure I've actually done the escaping correctly, though,
>     since Ninja's source says that a space preceded by 2N backslashes
>     represents 2N backslashes at the end of a filename, and

I guess you refer to [1], more specifically this quote:

  Rather than implement all of above, we follow what GCC/Clang produces:

      Backslashes escape a space or hash sign.

      When a space is preceded by 2N+1 backslashes, it is represents N
      backslashes followed by space.

      When a space is preceded by 2N backslashes, it represents 2N
      backslashes at the end of a filename.

      A hash sign is escaped by a single backslash. All other
      backslashes remain unchanged.

>         λ printf '%s\n' 'foo\' | sed 's/[# \\]/\\&/g' | xxd
>         00000000: 666f 6f5c 5c0a                           foo\\.
>     
>     So would they interpret that as the filename 'foo\\' instead of 'foo\' ?
>     (Or, no because the 2N slashes aren't followed by a SP, but a NL?)

I think it would be interpreted as "foo\\". I would say that we really
don't need to go too much into detail here. I very much hope that no
sane person would have literal "\ " in their paths. One might wonder
about Windows, where backslashes are common. But filenames cannot start
with a space there, so this is fine.

So I'd say we should only care about quoting ' ' and '#', nothing else.
We can still iterate going forward if we see that we're too naive.

>  generate-configlist.sh | 10 +++++++++-
>  meson.build            |  4 +++-
>  2 files changed, 12 insertions(+), 2 deletions(-)
> 
> diff --git a/generate-configlist.sh b/generate-configlist.sh
> index 75c39ade20..091efd4564 100755
> --- a/generate-configlist.sh
> +++ b/generate-configlist.sh
> @@ -36,3 +37,10 @@ print_config_list () {
>  	echo
>  	print_config_list
>  } >"$OUTPUT"
> +
> +if test -n "$DEPFILE"
> +then
> +	printf "$OUTPUT: %s\n" "$0" "$SOURCE_DIR"/Documentation/*config.adoc \

I think it's a tiny bit hacky that we output the script itself as a
dependency here, and that it would be cleaner to do this via
`depend_files` in the target itself.

> +	    "$SOURCE_DIR"/Documentation/config/*.adoc |
> +	    sed 's/[# \\]/\\&/g' >"$DEPFILE"
> +fi

>From the above rules I would think that we should simply ignore
backslashes here. As the last rule says, "All other backslashes remain
unchanged.".

> diff --git a/meson.build b/meson.build
> index 3a1d12caa4..fb5d7367f5 100644
> --- a/meson.build
> +++ b/meson.build
> @@ -720,11 +720,13 @@ endif
>  
>  builtin_sources += custom_target(
>    output: 'config-list.h',
> +  depfile: 'config-list.h.d',
>    command: [
>      shell,
> -    meson.current_source_dir() + '/generate-configlist.sh',
> +    meson.current_source_dir() / 'generate-configlist.sh',
>      meson.current_source_dir(),
>      '@OUTPUT@',
> +    '@DEPFILE@',

I didn't know about `@DEPFILE@`, nice.

Thanks!

Patrick

[1]: https://github.com/ninja-build/ninja/blob/cc60300ab94dae9bb28fece3c9b7c397235b17de/src/depfile_parser.in.cc#L27